VERSION 5.00
Object = "{853AAF94-E49C-11D0-A303-0040C711066C}#4.3#0"; "DicomObjects.ocx"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5400
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8325
   LinkTopic       =   "Form1"
   ScaleHeight     =   360
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   555
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Zoom Centre"
      Height          =   1215
      Left            =   5760
      TabIndex        =   3
      Top             =   1440
      Width           =   1935
      Begin VB.OptionButton LastMouseClick 
         Caption         =   "Last Mouse Click"
         Height          =   255
         Left            =   240
         TabIndex        =   5
         Top             =   720
         Width           =   1575
      End
      Begin VB.OptionButton ImageCentre 
         Caption         =   "Centre of image"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   360
         Value           =   -1  'True
         Width           =   1455
      End
   End
   Begin MSComctlLib.Slider Slider1 
      Height          =   4335
      Left            =   7920
      TabIndex        =   2
      Top             =   600
      Width           =   375
      _ExtentX        =   661
      _ExtentY        =   7646
      _Version        =   393216
      Orientation     =   1
      Min             =   -10
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Load Image"
      Height          =   375
      Left            =   5880
      TabIndex        =   1
      Top             =   720
      Width           =   1335
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   6120
      Top             =   4680
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin DicomObjects.DicomViewer DicomViewer1 
      Height          =   4935
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   5535
      _Version        =   262147
      _ExtentX        =   9763
      _ExtentY        =   8705
      _StockProps     =   35
      BackColor       =   4210752
      UseScrollBars   =   0   'False
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Zoom"
      Height          =   255
      Left            =   7800
      TabIndex        =   6
      Top             =   240
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim xinit As Integer, yinit As Integer, Origzoom As Single
Dim LastMouseX As Integer, LastMouseY As Integer

Private Sub Command1_Click()
    CommonDialog1.ShowOpen
    DicomViewer1.Images.ReadFile CommonDialog1.FileName
    DicomViewer1.CurrentImage.StretchToFit = False
    DicomViewer1.CurrentImage.Zoom = 1
End Sub

Private Sub DicomViewer1_MouseDown(Button As Integer, Shift As Integer, x As Long, y As Long)
    LastMouseX = x
    LastMouseY = y
End Sub

Private Sub Slider1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

    ' set up inital zoom values here, when slider first clicked - save rounding errors creeping in
    ' when zooming up and down
    
    xinit = DicomViewer1.CurrentImage.ActualScrollX
    yinit = DicomViewer1.CurrentImage.ActualScrollY
    Origzoom = DicomViewer1.CurrentImage.ActualZoom
    
End Sub

Private Sub Slider1_Scroll()
    Dim Image As DicomImage, oldzoom As Single, newzoom As Single
    Dim CentreX As Integer, CentreY As Integer
    Set Image = DicomViewer1.CurrentImage
    newzoom = 2 ^ (Slider1 / 4)
    oldzoom = Image.ActualZoom ' this allows for a stretched to fit image also
    
    If ImageCentre Then
        CentreX = DicomViewer1.Width / 2
        CentreY = DicomViewer1.Height / 2
    Else
        CentreX = LastMouseX
        CentreY = LastMouseY
    End If
      
    Image.ShowUpdates = False  ' prevent multiple updates
    
    Image.Zoom = newzoom
    
    Image.ScrollX = xinit - (CentreX + xinit) * (1 - Image.Zoom / Origzoom)
    Image.ScrollY = yinit - (CentreY + yinit) * (1 - Image.Zoom / Origzoom)
    
    Image.StretchToFit = False
    Image.ShowUpdates = True
    
End Sub





